// from /include/uapi/linux/if.h

type
  __caddr_t = pchar;
  caddr_t   = __caddr_t;

  ifmap = record
       mem_start: culong;
       mem_end  : culong;
       base_addr: cushort;
       irq      : cuint8;
       dma      : cuint8;
       port     : cuint8;
       (* 3 bytes spare *)
  end;
  Tifmap = ifmap;
  Pifmap = ^ifmap;
  PTifmap = Pifmap;

  if_settings = record
  	type_: cuint; (* Type of physical device or protocol *)
  	size:  cuint;	(* Size of the data allocated by the caller *)
    ifs_ifsu: record
  	  case byte of
  		  (* {atm/eth/dsl}_settings anyone ? *)
  		  1: ( raw_hdlc:    Praw_hdlc_proto );
  		  2: ( cisco:       Pcisco_proto );
  		  3: ( fr:          Pfr_proto );
  		  4: ( fr_pvc:      Pfr_proto_pvc );
  		  5: ( fr_pvc_info: Pfr_proto_pvc_info );
  		  6: ( x25:         Px25_hdlc_proto);

  		  (* interface settings *)
  		  7: ( sync:        Psync_serial_settings );
  		  8: ( te1:         Pte1_settings );
    end;
  end;

  ifreq = record
    case byte of
      1: (  // allow indirect data usage through ifr_ifrn and ifr_ifru structures
            ifr_ifrn : record
              ifrn_name : array[0..(IFNAMSIZ)-1] of char;
            end;
            ifr_ifru : record
              case byte of
                1 : ( ifru_addr      : sockaddr );
                2 : ( ifru_dstaddr   : sockaddr );
                3 : ( ifru_broadaddr : sockaddr );
                4 : ( ifru_netmask   : sockaddr );
                5 : ( ifru_hwaddr    : sockaddr );
                6 : ( ifru_flags     : cshort );
                7 : ( ifru_ivalue    : cint );
                8 : ( ifru_mtu       : cint );
                9 : ( ifru_map       : ifmap );
                10: ( ifru_slave     : array[0..(IFNAMSIZ)-1] of char );
                11: ( ifru_newname   : array[0..(IFNAMSIZ)-1] of char );
                12: ( ifru_data      : __caddr_t );
                13: ( ifru_settings  : if_settings );
            end;
         );
      2: (  // allow direct data usage without ifr_ifrn and ifr_ifru structures (slightly different field naming)
            ifr_name : array[0..(IFNAMSIZ)-1] of char;                 (* interface name        *)
            case byte of
              1 : ( ifr_addr      : sockaddr );                        (* address               *)
              2 : ( ifr_dstaddr   : sockaddr );                        (* other end of p-p lnk  *)
              3 : ( ifr_broadaddr : sockaddr );                        (* broadcast address     *)
              4 : ( ifr_netmask   : sockaddr );                        (* interface net mask    *)
              5 : ( ifr_hwaddr    : sockaddr );                        (* MAC address           *)
              6 : ( ifr_flags     : cshort );                          (* flags                 *)
              7 : ( ifr_metric    : cint );                            (* metric                *)
              8 : ( ifr_mtu       : cint );                            (* mtu                   *)
              9 : ( ifr_map       : ifmap );                           (* device map            *)
              10: ( ifr_slave     : array[0..(IFNAMSIZ)-1] of char );  (* slave device          *)
              11: ( ifr_newname   : array[0..(IFNAMSIZ)-1] of char );  (* New name              *)
              12: ( ifr_data      : __caddr_t );                       (* for use by interface  *)
              13: ( ifr_bandwidth : cint );                            (* link bandwidth        *)
              14: ( ifr_ifindex   : cint );                            (* interface index       *)
              15: ( ifr_qlen      : cint );                            (* Queue length          *)
              16: ( ifr_settings  : if_settings );                     (* Device/proto settings *)
         );
  end;
  Tifreq = ifreq;
  Pifreq = ^ifreq;
  PTifreq = Pifreq;
